var bricks = window.bricks || {};

bricks.ChartLine = class extend bricks.VBox {
	/*
	{
		data_url,
		data_params,
		method,
		data,
		line_options,
		nameField,
		valueFields
	}
	*/
	constructor(opts){
		super(opts);
		this.build_title_widget();
		this.build_description_widget();
		this.build_toolbar_widget();
		this.nameField = opts.nameField || 'name';
		this.valueFields = opts.valueField || ['value'];
		this.chart = new bricks.Filler();
		this.add_widget(this.chart);
		schedule_once(this.build_chart, 0.1);
	}
	async build_chart(){
		if (this.user_data){
			this.build_line(this.user_data);
		} else if (this.data_url){
			await this.build_line_using_url();
		}
	}
	values_from_data(data, name){
		var d = [];
		data.forEach(x => {
			d.push(x[name]);
		}
		return d;
	}
	lineinfo_from_data(data, name){
		return {
			name:name,
			type:'line',
			data:this.values_from_data(data, name)
		}
	}
	build_line(data){
		var n_data = [];
		var series = [];
		this.valueFields.forEach(v => {
			series.push(this.lineinfo_from_data(data, v));
		}
		data.forEach(d => {
			n_data.push(d[this.nameField]);
		});
		var e = this.chart.dom_element;
		this.chartOBj = echarts.init(e);
		var opts = {
			tooltip:{
				trigger:'axis'
			},
			legend:{
				data:this.valueFields
			}
			xAxis:{
				type:'category',
				data: n_value
			},
			yAxis:{
				type: 'value'
			},
			series:series
		}
		this.chartObj.setOption(opts);
		this.chartObj.on('click', this.click_handle.bind(this));
	}
	click_handle(params){
		this.bind('element_click', params);
	}
	async build_line_using_url(params){
		if (!params) params = {};
		var _params = bricks.extend({}, this.data_params);
		_params = bricks.extend(_params, params);
		var method = this.method || 'GET';
		var jc = bricks.HttpJson();
		d = jc.httpcall(this.data_url, {
			method:method,
			params:_params
		});
		if (d){
			await this.build_line(d);
		}
	}
}

bricks.Factory.register('ChartLine', bricks.ChartLine);
